#! /usr/bin/perl -w

#=============================================================================
#    G I M S  J A V A S C R I P T  .  P M
#
#    Written by C. Thomas
#
#    $Id: GIMSJavascript.pm,v 1.6 2010/06/28 16:03:04 cthomas Exp $
#=============================================================================
package GIMSJavascript;


#=============================================================================
#    U S E  /  R E Q U I R E
#=============================================================================
use strict;


#=============================================================================
#    P R O T O T Y P E S
#=============================================================================
sub printJavascript();


#=============================================================================
#    C O N F I G
#=============================================================================


#=============================================================================
#    G L O B A L  V A R I A B L E S
#=============================================================================


######################### BEGIN SUBROUTINES ##################################


#===================================================================
#    P R I N T  J A V A S C R I P T
#===================================================================
sub printJavascript()
{
  print <<"EOF";  

<script language="Javascript">

//=======================================================
//    H A N D L E  C O O K I E S
//=======================================================
function handleCookies() 
{
  var date_obj = new Date();
  var now = date_obj.getTime();
    
  return;
   
} // end of handleCookies()

//=======================================================
//    S E T  C O O K I E
//=======================================================
function setCookie(cookie_name, value, expires) 
{    
  if (expires == '')
  {
    document.cookie = cookie_name + "=" + escape(value) + ";";
  }
  else
  {
    document.cookie = cookie_name + "=" + escape(value) + "; expires=" + expires;
  }
                
  return;
    
} // end of setCookie()

//=======================================================
//    D E L E T E  C O O K I E
//=======================================================
function deleteCookie (cookie_name)
{
  var cookie_date = new Date ();  // current date & time
  cookie_date.setTime(cookie_date.getTime() - 1);
  document.cookie = cookie_name += "=; expires=" + cookie_date.toGMTString();
  
  return;
    
} // end of deteteCookie()

//=============================================================
//=   S T A R T  E X P E R I M E N T
//=============================================================
function startExperiment()
{  
  document.myForm.control_action.value = "StartExperiment";
  
  //===== Handle click
  document.myForm.start_btn.src = "images/StartClick.jpeg";
  var cmd = "document.myForm.start_btn.src = \\"images/Start.jpeg\\"";
  setTimeout(cmd, 100);

  //===== Submit
  setTimeout("document.myForm.submit();", 55);

  return;
  
} // end of startExperiment()

//=============================================================
//=   P A U S E   E X P E R I M E N T 
//=============================================================
function pauseExperiment()
{  
  document.myForm.control_action.value = "PauseExperiment";
  
  //===== Handle click
  document.myForm.pause_btn.src = "images/PauseClick.jpeg";
  var cmd = "document.myForm.pause_btn.src = \\"images/Pause.jpeg\\"";
  setTimeout(cmd, 100);
  
  //===== Submit
  setTimeout("document.myForm.submit();", 55);

  return;
  
} // end of pauseExperiment()

//=============================================================
//=   S T O P  E X P E R I M E N T 
//=============================================================
function stopExperiment()
{  
  document.myForm.control_action.value = "StopExperiment";
  
  //===== Handle click
  if (confirm("Sure you want to stop this experiment?"))
  {
    document.myForm.stop_btn.src = "images/StopClick.jpeg";
    var cmd = "document.myForm.stop_btn.src = \\"images/Stop.jpeg\\"";
    setTimeout(cmd, 100);
  
    //===== Submit
    setTimeout("document.myForm.submit();", 55);
  } // if they confirmed

  return;
  
} // end of stopExperiment()

//=============================================================
//=   G E T  E X P E R I M E N T  S T A T U S
//=============================================================
function getExperimentStatus()
{  
  document.myForm.control_action.value = "GetExperimentStatus";
  
  //===== Handle click
  document.myForm.status_btn.src = "images/StatusClick.jpeg";
  var cmd = "document.myForm.status_btn.src = \\"images/Status.jpeg\\"";
  setTimeout(cmd, 100);
  
  //===== Submit
  //setTimeout("document.myForm.submit();", 55);

  return;

} // end of getExperimentStatus()

function handleStorageOption()
{
  var store_val = '';

  for (var i=0; i < document.myForm.storage_type.length; i++)
  {
    if (document.myForm.storage_type[i].checked)
    {
      store_val = document.myForm.storage_type[i].value;
    }
  }
  
  if (store_val == 'local')
  {
    var cur_val = document.myForm.local_storage_dir.value;
    document.myForm.local_storage_dir.value = prompt("Local storage directory?", cur_val);

    // Display to user
    document.myForm.storage_options.value = document.myForm.local_storage_dir.value;
  }
  else if (store_val == 's3')
  {
    var cur_key = document.myForm.s3key.value;
    var cur_secret = document.myForm.s3secret.value;
    var cur_bucket = document.myForm.s3bucket.value;

    document.myForm.s3key.value = prompt("s3 key?", cur_key);
    document.myForm.s3secret.value = prompt("s3 secret?", cur_secret);
    document.myForm.s3bucket.value = prompt("s3 bucket?", cur_bucket);

    // Display to user
    document.myForm.storage_options.value = document.myForm.s3key.value + ":" + 
                                            document.myForm.s3secret.value + ":" + 
                                            document.myForm.s3bucket.value;
  }
  else if (store_val == 'ssh')
  {
    var cur_user = document.myForm.sshuser.value;
    var cur_host = document.myForm.sshhost.value;
    var cur_port = document.myForm.sshport.value;
    var cur_path = document.myForm.sshpath.value;
    var cur_privkey = document.myForm.sshkey.value;
    
    document.myForm.sshuser.value = prompt("SSH User?", cur_user);
    document.myForm.sshhost.value = prompt("SSH Host?", cur_host); 
    document.myForm.sshport.value = prompt("SSH Port?", cur_port);
    document.myForm.sshpath.value = prompt("SSH Path?", cur_path);
    document.myForm.sshkey.value = prompt("SSH Private key?", cur_privkey);

    // Display to user
    document.myForm.storage_options.value = document.myForm.sshuser.value + ":" +
                                            document.myForm.sshhost.value + ":" +
                                            document.myForm.sshport.value + ":" +
                                            document.myForm.sshpath.value + ":" +
                                            document.myForm.sshkey.value;
  }

  return;

} // end of handleStorageOption()


//=============================================================
//=   G E T  X M L  H T T P  O B J E C T
//=============================================================
function getXmlHttpObject()
{
  if (window.XMLHttpRequest)
  {
    // code for IE7+, Firefox, Chrome, Opera, Safari
    return new XMLHttpRequest();
  }
  if (window.ActiveXObject)
  {
    // code for IE6, IE5
    return new ActiveXObject("Microsoft.XMLHTTP");
  }
  return null;
} // end of getXmlHttpObject()

//=============================================================
//=   G E N E R A T E  I D
//=============================================================
function generateID()
{  
  xmlhttp=getXmlHttpObject();
  if (xmlhttp==null)
  {
    alert ("Your browser does not support XMLHTTP!");
    return;
  }
  
  var url="ajax/gims_ajax.cgi";
  url=url+"?function=genExpID";
    
  xmlhttp.onreadystatechange=stateChanged;
  xmlhttp.open("GET",url,true);
  xmlhttp.send(null);
  
} // end of generateID()


//=============================================================
//=   C R E A T E  N E W  E X P E R I M E N T
//=============================================================
function createNewExperiment(exp_id, location, device_name)
{  
  xmlhttp=getXmlHttpObject();
  if (xmlhttp==null)
  {
    alert ("Your browser does not support XMLHTTP!");
    return;
  }
  
  var url="ajax/gims_ajax.cgi";
  url=url+"?function=createNewExperiment";
  url=url+"&exp_id="+exp_id;
  url=url+"&location="+location;
  url=url+"&device_name="+device_name;
  
  xmlhttp.onreadystatechange=stateChanged;
  xmlhttp.open("GET",url,true);
  xmlhttp.send(null);
  
} // end of createNewExperiment()


//=============================================================
//=   R E F R E S H  E X P  I D S 
//=============================================================
function refreshExpIDs()
{
  xmlhttp=getXmlHttpObject();
  if (xmlhttp==null)
  {
    alert ("Your browser does not support XMLHTTP!");
    return;
  }
  
  var url="ajax/gims_ajax.cgi";
  url=url+"?function=getExpIDs";
    
  xmlhttp.onreadystatechange=stateChanged;
  xmlhttp.open("GET",url,true);
  xmlhttp.send(null);
  
  return;

} // end of refreshExpIDs()


//=============================================================
//=   R E F R E S H  E X P  D E V I C E  N A M E S
//=============================================================
function refreshExpDeviceNames(exp_id)
{
  xmlhttp=getXmlHttpObject();
  if (xmlhttp==null)
  {
    alert ("Your browser does not support XMLHTTP!");
    return;
  }
 
  var url="ajax/gims_ajax.cgi";
  url=url+"?function=getExpDevices";
  url=url+"&exp_id="+exp_id;
   
  xmlhttp.onreadystatechange=stateChanged;
  xmlhttp.open("GET",url,true);
  xmlhttp.send(null);
  
  return;

} // end of refreshExpDeviceNames()


//=============================================================
//=   R E F R E S H  D E V I C E  N A M E S
//=============================================================
function refreshDeviceNames(loc)
{
  xmlhttp=getXmlHttpObject();
  if (xmlhttp==null)
  {
    alert ("Your browser does not support XMLHTTP!");
    return;
  }
 
  var url="ajax/gims_ajax.cgi";
  url=url+"?function=getAllDevices";
 
  if (loc != '')
  {
    url=url+"&location="+exp_id;
  } 
  xmlhttp.onreadystatechange=stateChanged;
  xmlhttp.open("GET",url,true);
  xmlhttp.send(null);
  
  return;

} // end of refreshDeviceNames()


//=============================================================
//=   S T A T E  C H A N G E D
//=============================================================
function stateChanged()
{
  if (xmlhttp.readyState==4)
  {    
    var resp = xmlhttp.responseText.split("\\n");
    if (resp[0] && resp[1])
    {
      //===== genExpID
      if (resp[0] == "genExpID")
      {
        // Set the text field to this new ID
        var obj = document.getElementById('exp_id_div');
        obj.innerHTML = resp[1];
        document.myForm.experiment_id.value = resp[1];
       } // generateID

       //===== createNewExperiment
       else if (resp[0] == "createNewExperiment")
       {
         var exp_id = document.myForm.experiment_id.value;

         // Set the div with the response
         var obj = document.getElementById('response_div');
         obj.innerHTML = resp[1];
         obj.style.display='block';

         // Reset the mode select
         document.myForm.mode[0].selected = 'true';

         // Refresh the list of ExperimentIDs
         refreshExpIDs();

       } // createNewExperiment

       //===== getExpIDs
       else if (resp[0] == "getExpIDs")
       {
         var exp_select = document.myForm.exp_select;

         // Get all the options returned from database
         var id_response = resp[1];
         var ids = id_response.split(" ");

         // Show the ExpID select
         var obj = document.getElementById('exp_select_row');
         obj.style.display = 'table-row';
         
         // Delete all options from select
         exp_select.options.length = 1;

         // Enable the ExpID select
         exp_select.disabled = false;

         // Now add back the options we got from AJAX
         for (i = 0; i < ids.length; i++)
         {
           // Split each response on pipe character
           var fields = ids[i].split("|");
           var expID = fields[0];
           var status = fields[1];
           var last_update = fields[2];

           // Build new option text
           var opt_text = expID + " " + status + " (" + last_update + ")";

           // Add the option 
           exp_select.options[exp_select.options.length] = 
             new Option(opt_text, expID);
 
           // Select this option, if it matches experiment_id
           if (expID == document.myForm.experiment_id.value)
           {
             exp_select.options[exp_select.options.length-1].selected = true;
           } 
         } // for each ID
       } // getExpIDs

       //===== getExpDevices
       else if (resp[0] == "getExpDevices")
       {
         // Get all the devices
         var dev_response  = resp[1];
         var devices = dev_response.split(" ");

         // Select the first device for this experiment
         selectDevice(devices[0]);         
       } // getExpDevices

       //====== getAllDevices
       else if (resp[0] == "getAllDevices")
       {
         // Make array from returned devices
         var dev_response = resp[1];
         var devices = dev_response.split(" ");

         var device_name = document.myForm.device_name;

         // Clear the device select
         device_name.options.length = 1;

         // Add back the devices
         for (i = 0; i < devices.length; i++)
         {
           // Add the option 
           device_name.options[device_name.options.length] = 
             new Option(devices[i], devices[i]);
         } // for each device
       } // getAllDevices
    } // response

    // Illegal Command
    else
    {
      alert("Ajax error!");
      //var obj = document.getElementById('exp_id_div');
      //obj.innerHTML = "ERROR!";
    } // unknown command
  } // if readyState
} // end of stateChanged()


//=============================================================
//=   S E L E C T  D E V I C E
//=============================================================
function selectDevice(dev)
{
  var device_name = document.myForm.device_name;

  // Select the device for this experiment
  for (i = 0; i < device_name.length; i++)
  {
    if (device_name.options[i].value == dev)
    {
      device_name.options[i].selected = true;
    } // if we have a match
  } // for each device

  return;

} // end of selectDevice()


//=============================================================
//=   S E L E C T  C L E A R  D E V I C E
//=============================================================
function selectClearDevice(dev)
{
  var device_name = document.myForm.device_name;

  // Remove all options from the device select
  device_name.options.length = 0;

  // Add the option 
  device_name.options[device_name.options.length] = 
    new Option(dev, dev);

  return;

} // end of selectClearDevice()


//=============================================================
//=   G E T  E X P I R E S  T I M E S T A M P
//=============================================================
function getExpiresTimestamp(days)
{
  var date_obj = new Date();
  var cur_date = date_obj.getDate();
  var expires = '';

  if (days == '')
  {
    days = 0;
  }

  // Make a new date
  cur_date = (cur_date + days);
  date_obj.setDate(cur_date);
  expires = date_obj.toGMTString();

  return(expires);

} // end of getExpiresTimestamp()


//=============================================================
//=   H A N D L E  A C T I O N  S U B M I T
//=============================================================
function handleActionSubmit()
{
  var location = "";
  var device_name = document.myForm.device_name.value;
  var experiment_id = document.myForm.experiment_id.value;

  //===== Verify then submit
  if (document.myForm.mode.value == '')
  {
    alert("Must select an action to perform!");
    document.myForm.mode.focus();
    return;
  }
  if (document.myForm.device_name.value == '')
  {
    alert("Must select a device name!");
    document.myForm.device_name.focus();
    return;
  }
  if (document.myForm.experiment_id.value == '')
  {
    alert("Must supply or generate an ExperimentID!");
    document.myForm.exp_select.focus();
    return;
  }

  //===== Set our cookies
  if (device_name)
  {
    var expires = getExpiresTimestamp(1);
    setCookie('device_name', device_name, expires);  
  }
  if (experiment_id)
  {
    var expires = getExpiresTimestamp(1);
    setCookie('experiment_id', experiment_id, expires);
  }

  //===== Use AJAX to create a new experiment
  if (document.myForm.mode.value == 'create_new_experiment')
  {
    var args = device_name.split(':');
    loc = args[0];
    dev = args[1];

    createNewExperiment(experiment_id, loc, dev);
  }

  //===== OR submit
  else
  {
    //===== All is well, submit
    document.myForm.submit();
  }
  return;

} // end of handleActionSubmit()


//=============================================================
//=   H A N D L E  A C T I O N  S E L E C T
//=============================================================
function handleActionSelect()
{
  if (document.myForm.mode.value == 'create_new_experiment')
  {
    generateID(); 

    // Disable exp_select
    document.myForm.exp_select.disabled = true;
    
    // Hide exp_select 
    var obj = document.getElementById('exp_select_row');
    obj.style.display = 'none';
  }
  else
  {
    var exp_value = document.myForm.exp_select.value;

    // Enable exp_select
    document.myForm.exp_select.disabled = false;

    // Show exp_select  
    var obj = document.getElementById('exp_select_row');
    obj.style.display = 'table-row';

    // Set the ExperimentID
    var obj = document.getElementById('exp_id_div');
    obj.innerHTML = exp_value;
    document.myForm.experiment_id.value = exp_value;
  }

  return;

} // end of handleActionSelect()


//=============================================================
//=   H A N D L E  E X P E R I M E N T  I D  S E L E C T
//=============================================================
function handleExperimentIDSelect()
{
  var exp_id = document.myForm.exp_select.value;

  // Set the device_name select to the device for this
  // experiment
  if (exp_id)
  {
    refreshExpDeviceNames(exp_id);
  } // if we have a value
  else
  {
    // reset 
    document.myForm.device_name.options[0].selected = true;
  } // no value

  // Set the ExperimentID div to display this value
  var obj = document.getElementById('exp_id_div');
  obj.innerHTML = exp_id;
  document.myForm.experiment_id.value = exp_id;

  return;
} // end of handleExperimentIDSelect()


//=============================================================
//=   H A N D L E  L I B P C A P  S T R
//=============================================================
function handleLibpcapStr()
{
  var input = document.getElementById('libpcap_input');
  var arrow = document.getElementById('libpcap_arrow');

  if (input.style.display == 'none')
  {
    input.style.display = 'block';
    arrow.src='images/DownArrow.gif';
  }
  else
  {
    input.style.display = 'none';
    arrow.src='images/RightArrow.gif';
  }
  return;
} // end of handleLibpacapStr()


//=============================================================
//=   H A N D L E  M E T A  D A T A 
//=============================================================
function handleMetaData()
{
  var input = document.getElementById('meta_data_input');
  var arrow = document.getElementById('meta_data_arrow');

  if (input.style.display == 'none')
  {
    input.style.display = 'block';
    arrow.src='images/DownArrow.gif';
  }
  else
  {
    input.style.display = 'none';
    arrow.src='images/RightArrow.gif';
  }
  return;
} // end of handleMetaData()


EOF

  print"</script>\n";
  
} # end of printJavascript()


1
